import { HTMLNode } from "./html-node.class";
export class BaseComponent {
    constructor(main) {
        this.deepSync = false;
        this.main = main;
        this.main.on("content-init", () => this.check());
    }
    destroy() { }
    ;
    check() {
        const candidate = new HTMLNode(this.selector);
        const mustDestroy = (!!this.el && this.deepSync)
            || (!!this.el && this.el.nativeElement !== candidate.nativeElement);
        const mustStart = (!this.el || mustDestroy) && candidate.length > 0;
        if (mustDestroy)
            this.destroy();
        if (mustStart)
            this.start(candidate);
    }
    start(candidate) {
        this.el = candidate;
        this.init();
    }
}
