import { Subject, fromEvent } from "rxjs";
import { map, take } from "rxjs/operators";
export class Main {
    constructor() {
        this.emitters = {};
        this.createEvent("content-init");
        this.init$ =
            fromEvent(window, "load")
                .pipe(map(() => true), take(1));
        this.init$.subscribe(() => this.trigger("content-init"));
    }
    createEvent(...args) {
        args.forEach(name => this.emitters[name] = new Subject());
    }
    on(name, callback) {
        return name.split(" ").map(label => !!this.emitters[label] && this.emitters[label].subscribe((arg) => callback(arg)));
    }
    trigger(evt, arg = true) {
        !!this.emitters[evt] && this.emitters[evt].next(arg);
    }
}
